diff -Nur irc2.10.3p7/common/common_def.h irc2.10.3p7+hemp2+DK+B5/common/common_def.h
--- irc2.10.3p7/common/common_def.h	Fri Feb  5 00:26:35 1999
+++ irc2.10.3p7+hemp2+DK+B5/common/common_def.h	Tue May 11 15:25:01 2004
@@ -54,6 +54,7 @@
 #define PUNCT 8
 #define DIGIT 16
 #define SPACE 32
+#define VALID 64
 
 #define isalpha(c) (char_atribs[(u_char)(c)]&ALPHA)
 #define isspace(c) (char_atribs[(u_char)(c)]&SPACE)
@@ -74,6 +75,9 @@
 #define isgraph(c) ((char_atribs[(u_char)(c)]&PRINT) && \
 		    ((u_char)(c) != (u_char)0x20))
 #define ispunct(c) (!(char_atribs[(u_char)(c)]&(CNTRL|ALPHA|DIGIT)))
+#ifdef	RESTRICT_USERNAMES
+#define isvaliduser(c) (char_atribs[(u_char)(c)]&VALID)
+#endif
 
 #ifdef DEBUGMODE
 # define Debug(x) debug x
diff -Nur irc2.10.3p7/common/match.c irc2.10.3p7+hemp2+DK+B5/common/match.c
--- irc2.10.3p7/common/match.c	Wed Jul  4 23:44:40 2001
+++ irc2.10.3p7+hemp2+DK+B5/common/match.c	Tue May 11 15:25:01 2004
@@ -110,34 +110,37 @@
 /* 16-23 */	CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL,
 /* 24-31 */	CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL,
 /* space */	PRINT|SPACE,
-/* !"#$%&'( */	PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT,
-/* )*+,-./ */	PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT,
-/* 0123 */	PRINT|DIGIT, PRINT|DIGIT, PRINT|DIGIT, PRINT|DIGIT,
-/* 4567 */	PRINT|DIGIT, PRINT|DIGIT, PRINT|DIGIT, PRINT|DIGIT,
-/* 89:; */	PRINT|DIGIT, PRINT|DIGIT, PRINT, PRINT,
-/* <=>? */	PRINT, PRINT, PRINT, PRINT,
-/* @ */		PRINT,
-/* ABC */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* DEF */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* GHI */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* JKL */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* MNO */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* PQR */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* STU */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* VWX */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* YZ[ */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* \]^ */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* _`  */	PRINT, PRINT,
-/* abc */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* def */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* ghi */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* jkl */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* mno */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* pqr */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* stu */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* vwx */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* yz{ */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
-/* \}~ */	PRINT|ALPHA, PRINT|ALPHA, PRINT|ALPHA,
+/* !"#$ */	PRINT, PRINT, PRINT, PRINT,
+/* %&'( */	PRINT, PRINT, PRINT, PRINT,
+/* )*+ */	PRINT, PRINT, PRINT,
+/* ,-. */	PRINT, PRINT|VALID, PRINT|VALID,
+/* /01 */	PRINT, PRINT|DIGIT|VALID, PRINT|DIGIT|VALID,
+/* 234 */	PRINT|DIGIT|VALID, PRINT|DIGIT|VALID, PRINT|DIGIT|VALID,
+/* 567 */	PRINT|DIGIT|VALID, PRINT|DIGIT|VALID, PRINT|DIGIT|VALID,
+/* 89: */	PRINT|DIGIT|VALID, PRINT|DIGIT|VALID, PRINT,
+/* ;<= */	PRINT, PRINT, PRINT,
+/* >?@ */	PRINT, PRINT, PRINT,
+/* ABC */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* DEF */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* GHI */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* JKL */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* MNO */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* PQR */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* STU */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* VWX */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* YZ[ */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* \]^ */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA,
+/* _`  */	PRINT|VALID,PRINT,
+/* abc */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* def */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* ghi */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* jkl */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* mno */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* pqr */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* stu */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* vwx */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* yz{ */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA|VALID,
+/* \}~ */	PRINT|ALPHA|VALID, PRINT|ALPHA|VALID, PRINT|ALPHA,
 /* del */	0,
 /* 80-8f */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 /* 90-9f */	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
diff -Nur irc2.10.3p7/common/msg_def.h irc2.10.3p7+hemp2+DK+B5/common/msg_def.h
--- irc2.10.3p7/common/msg_def.h	Wed Feb 25 17:28:48 2004
+++ irc2.10.3p7+hemp2+DK+B5/common/msg_def.h	Tue May 11 15:25:01 2004
@@ -32,6 +32,12 @@
 #define MSG_QUIT     "QUIT"	/* QUIT */
 #define MSG_SQUIT    "SQUIT"	/* SQUI */
 #define MSG_KILL     "KILL"	/* KILL */
+#if defined(OPER_KLINE) || defined(LOCOP_KLINE)
+#define MSG_KLINE    "KLINE"	/* KLIN */
+#endif
+#if defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+#define MSG_TKLINE   "TKLINE"	/* TKLI */
+#endif
 #define MSG_INFO     "INFO"	/* INFO */
 #define MSG_LINKS    "LINKS"	/* LINK */
 #define MSG_SUMMON   "SUMMON"	/* SUMM */
@@ -74,5 +80,10 @@
 #define	MSG_HASH     "HAZH"	/* HASH */
 #define	MSG_DNS      "DNS"	/* DNS  -> DNSS */
 #define	MSG_POST     "POST"
-
-#define MAXPARA    15 
+#ifdef SERVER_MAP
+#define MSG_MAP                "MAP"
+#endif
+#ifdef OPER_SET
+#define MSG_SET               "SET"   /* SET */
+#endif
+#define MAXPARA    15
diff -Nur irc2.10.3p7/common/numeric_def.h irc2.10.3p7+hemp2+DK+B5/common/numeric_def.h
--- irc2.10.3p7/common/numeric_def.h	Sat Feb 10 20:11:05 2001
+++ irc2.10.3p7+hemp2+DK+B5/common/numeric_def.h	Tue May 11 15:25:01 2004
@@ -123,8 +123,18 @@
 #define	RPL_YOURHOST         002
 #define	RPL_CREATED          003
 #define	RPL_MYINFO           004
+#ifdef SEND_ISUPPORT
+#define RPL_ISUPPORT	     005
+#define RPL_BOUNCE	      10
+#else
 #define	RPL_BOUNCE           005
-
+#endif
+#ifdef SERVER_MAP
+#define RPL_MAP               15        /* Undernet extension */
+#define RPL_MAPMORE	      16        /* Undernet extension */
+#define RPL_MAPEND	      17        /* Undernet extension */
+#define RPL_MAPSTART	      18        /* +hemp */
+#endif
 /*
  * Errors are in the range from 400-599 currently and are grouped by what
  * commands they come from.
@@ -195,6 +205,10 @@
 #define ERR_NOOPERHOST       491
 #define ERR_NOSERVICEHOST    492
 
+#ifdef NOSTATSK
+#define ERR_STATSKLINE       499
+#endif
+
 #define ERR_UMODEUNKNOWNFLAG 501
 #define ERR_USERSDONTMATCH   502
 
@@ -232,6 +246,7 @@
 
 #define RPL_NOTOPIC          331
 #define RPL_TOPIC            332
+#define RPL_TOPICWHOTIME     333
 
 #define RPL_INVITING         341
 #define	RPL_SUMMONING        342
@@ -299,7 +314,7 @@
 #define RPL_STATSQLINE       217
 #define RPL_STATSYLINE       218
 #define RPL_ENDOFSTATS       219
-
+#define RPL_STATSPLINE	     220
 #define RPL_UMODEIS          221
 
 #define RPL_SERVICEINFO      231
@@ -335,3 +350,5 @@
 #define	RPL_TRACEEND         262
 #define	RPL_TRYAGAIN         263
 
+#define RPL_LOCALUSERS       265
+#define RPL_GLOBALUSERS      266
diff -Nur irc2.10.3p7/common/parse.c irc2.10.3p7+hemp2+DK+B5/common/parse.c
--- irc2.10.3p7/common/parse.c	Thu Feb 26 20:51:31 2004
+++ irc2.10.3p7+hemp2+DK+B5/common/parse.c	Tue May 11 15:25:01 2004
@@ -64,6 +64,12 @@
   { MSG_KILL,    m_kill,     MAXPARA, MSG_LAG|MSG_REG|MSG_NOU, 0, 0, 0L},
 #endif
 #ifndef CLIENT_COMPILE
+#if	defined(OPER_KLINE) || defined(LOCOP_KLINE)
+  { MSG_KLINE,   m_kline,    MAXPARA, MSG_LAG|MSG_REG|MSG_OP|MSG_LOP, 0,0, 0L},
+#endif
+#if defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+  { MSG_TKLINE,  m_tkline,   MAXPARA, MSG_LAG|MSG_REG|MSG_OP|MSG_LOP, 0,0, 0L},
+#endif
   { MSG_USER,    m_user,     MAXPARA, MSG_LAG|MSG_NOU, 0, 0, 0L},
   { MSG_AWAY,    m_away,     MAXPARA, MSG_LAG|MSG_REGU, 0, 0, 0L},
   { MSG_UMODE,   m_umode,    MAXPARA, MSG_LAG|MSG_REGU, 0, 0, 0L},
@@ -121,6 +127,12 @@
 # endif
 					, 0, 0, 0L},
 #endif
+#ifdef SERVER_MAP
+  { MSG_MAP,  m_map,   		MAXPARA, MSG_LAG|MSG_REG, 0, 0, 0L},
+#endif
+#ifdef OPER_SET
+  { MSG_SET,  m_set,		MAXPARA, MSG_LAG|MSG_REGU|MSG_OP|MSG_LOP , 0, 0, 0L},
+#endif
   { MSG_POST,    m_post,     MAXPARA, MSG_NOU, 0, 0, 0L},
 #endif /* !CLIENT_COMPILE */
   { (char *) 0, (int (*)()) 0, 0, 0, 0, 0, 0L}
@@ -173,6 +185,71 @@
 	return acptr;
     }
 
+aClient *find_matching_client(mask,cptr)
+char *mask;
+Reg	aClient *cptr;
+{
+	aClient *acptr = cptr;
+	Reg char *ch;
+	int wild = 0;
+	
+	/* try to find exact match */	
+	acptr = find_client(mask,NULL);
+	if (!acptr)
+	{
+		aServer *asptr;
+		int wild = 0, dot = 0;
+		/* check if we should check against wilds */
+		for (ch = mask; *ch; ch++)
+		{
+			if (*ch == '*' || *ch == '?')
+			{
+				wild = 1;
+				break;
+			}
+			if (*ch == '.')
+			{
+				dot = 1;
+				break;
+			}
+		}
+		
+		if (!wild && !dot)
+		{
+			return cptr;
+		}
+		(void) collapse(mask);
+		
+		/* try to match some servername against mask */
+		for (asptr = svrtop; asptr; asptr = asptr->nexts)
+		{
+			if (!match(asptr->bcptr->name,mask) ||
+			    !match(mask,asptr->bcptr->name))
+			{
+				acptr = asptr->bcptr;
+				break;
+			}
+		}
+		
+		/* no match, try services */
+		if (!acptr)
+		{
+			aService *sp;
+			for (sp = svctop;sp;sp = sp->nexts)
+			{
+				if (!match(sp->bcptr->name,mask) ||
+				    !match(mask,sp->bcptr->name))
+				{
+					acptr = sp->bcptr;
+					break;
+				}
+			}
+		}
+
+	}
+
+	return acptr ? acptr : cptr;	
+}
 #else /* CLIENT_COMPILE */
 
 aClient *find_client(name, cptr)
@@ -190,7 +267,7 @@
 	return cptr;
     }
 #endif /* CLIENT_COMPILE */
-
+#ifndef CLIENT_COMPILE
 /*
 **  Find a user@host (server or user).
 **
@@ -209,20 +286,39 @@
 
 	*count = 0;
 	if (user)
-		for (c2ptr = client; c2ptr; c2ptr = c2ptr->next) 
-		    {
-			if (!MyClient(c2ptr)) /* implies mine and a user */
-				continue;
-			if ((!host || !match(host, c2ptr->user->host)) &&
-			     mycmp(user, c2ptr->user->username) == 0)
-			    {
-				(*count)++;
-				res = c2ptr;
-			    }
-		    }
+	{
+		if (host)
+		{
+			anUser *auptr;
+			for (auptr = hash_find_hostname(host,NULL); auptr; auptr = auptr->hnext)
+			{
+				if (MyConnect(auptr->bcptr) && !mycmp(user,auptr->username))
+				{
+					(*count)++;
+					res = auptr->bcptr;
+				}
+			}
+		}
+		else
+		{
+			int i;
+			for (i = 0; i <= highest_fd; i++)
+			{
+				if (!(c2ptr = local[i]) || !IsRegisteredUser(c2ptr))
+				{
+					continue;
+				}
+				if (!mycmp(user,c2ptr->user->username))
+				{
+					(*count)++;
+					res = c2ptr;
+				}
+			}
+	    }
+	}
 	return res;
     }
-
+#endif /* !CLIENT_COMPILE */
 /*
 **  Find server by name.
 **
@@ -766,7 +862,12 @@
 	if (index(sender, '.') /* <- buggy, it could be a service! */
 	    && !index(sender, '@')) /* better.. */
 	    {
-		sendto_flag(SCH_LOCAL, "Squitting unknown %s brought by %s.",
+#ifdef LOCAL_REJECTIONS_ONLY
+			sendto_flag(SCH_NOTICE,
+#else
+			sendto_flag(SCH_LOCAL, 
+#endif
+			"Squitting unknown %s brought by %s.",
 			    sender, get_client_name(cptr, FALSE));
 		sendto_one(cptr, ":%s SQUIT %s :(Unknown from %s)",
 			   me.name, sender, get_client_name(cptr, FALSE));
@@ -781,7 +882,12 @@
 	 * if we get here and sender is a service, we should probably issue
 	 * a kill in this case! -krys
 	 */
-		sendto_flag(SCH_LOCAL, "Dropping unknown %s brought by %s.",
+#ifdef LOCAL_REJECTIONS_ONLY
+	sendto_flag(SCH_NOTICE,
+#else
+	sendto_flag(SCH_LOCAL,
+#endif
+		"Dropping unknown %s brought by %s.",
 			    sender, get_client_name(cptr, FALSE));
 }
 #endif
diff -Nur irc2.10.3p7/common/parse_ext.h irc2.10.3p7+hemp2+DK+B5/common/parse_ext.h
--- irc2.10.3p7/common/parse_ext.h	Wed Sep  3 19:45:17 1997
+++ irc2.10.3p7+hemp2+DK+B5/common/parse_ext.h	Tue May 11 15:25:01 2004
@@ -44,6 +44,7 @@
 EXTERN aClient *find_mask __P((char *name, aClient *cptr));
 EXTERN aServer *find_tokserver __P((int token, aClient *cptr, aClient *c2ptr));
 EXTERN aClient *find_name __P((char *name, aClient *cptr));
+EXTERN aClient *find_matching_client __P((char *mask, aClient *cptr));
 #else /* CLIENT_COMPILE */
 EXTERN aClient *find_client __P((char *name, aClient *cptr));
 EXTERN aClient *find_server __P((char *name, aClient *cptr));
diff -Nur irc2.10.3p7/common/send.c irc2.10.3p7+hemp2+DK+B5/common/send.c
--- irc2.10.3p7/common/send.c	Sat Oct 11 03:09:36 2003
+++ irc2.10.3p7+hemp2+DK+B5/common/send.c	Tue May 11 15:25:01 2004
@@ -1391,6 +1391,9 @@
 	{ SCH_SERVICE,	"&SERVICES",	NULL },
 	{ SCH_DEBUG,	"&DEBUG",	NULL },
 	{ SCH_AUTH,	"&AUTH",	NULL },
+#ifdef CLIENTS_CHANNEL
+	{ SCH_CLIENTS,	"&CLIENTS",	NULL },
+#endif
 };
 
 
@@ -1515,6 +1518,12 @@
 	** And the rest... just count, I got 154 --Beeth
 	*/
 	char	linebuf[1500];
+#ifdef LOG_IP
+        char    *rip,*lip;
+#ifndef INET6
+        char    tip[18];
+#endif
+#endif /* LOG_IP */
 	/*
 	** This is a potential buffer overflow.
 	** I mean, when you manage to keep ircd
@@ -1522,6 +1531,9 @@
 	*/
 	char	buf[12];
 	int	logfile;
+#ifdef LOG_IP
+        u_short rport,lport;
+#endif /* LOG_IP */
 
 	logfile = msg ? connlog : userlog;
 
@@ -1543,15 +1555,63 @@
 			(int) (duration % 60));
 	}
 
+#ifdef LOG_IP
+        /*-
+         * New connection log format after looooong discussion:
+         *    [ident@remoteip#remoteport,localip#localport]
+         * --Yegg, 2001-05-09
+         */
+        lport = cptr->acpt != NULL ? cptr->acpt->port : 0;
+        rport = cptr->port;
+
+#ifdef INET6
+        lip = cptr->acpt != NULL ? inetntop(AF_INET6, (char *)&cptr->acpt->ip,
+                       mydummy, MYDUMMY_SIZE) : "<unknown>";
+        rip = inetntop(AF_INET6, (char *)&cptr->ip,
+                       mydummy2, MYDUMMY_SIZE);
+#else
+        if (cptr->acpt != NULL)
+        {
+                lip = inetntoa((char *)&cptr->acpt->ip);
+                strncpyzt(tip, lip, 18);
+                lip = tip;
+        }
+        else
+        {
+                lip = "<unknown>";
+        }
+        rip = inetntoa((char *)&cptr->ip);
+#endif
+
+#endif /* LOG_IP */
+
 	/*
 	** Aha, cptr->firsttime is time when user connected,
 	** so we syslog() it anyway. I'm waving big
 	** "rewrite log format" flag --Beeth.
 	*/
 	(void)sprintf(linebuf,
-		"%s (%s): %s@%s [%s] %c %lu %luKb %lu %luKb\n",
+#ifndef LOG_IP
+#ifdef LOG_IRCNAME
+                "%s (%s): %s@%s [%s] [%s] %c %lu %luKb %lu %luKb\n",
+#else
+                "%s (%s): %s@%s [%s] %c %lu %luKb %lu %luKb\n",
+#endif
+#else /* LOG_IP */
+#ifdef LOG_IRCNAME
+                "%s (%s): %s@%s [%s@%s#%u,%s#%u] [%s] %c %lu %luKb %lu %luKb\n",
+#else
+                "%s (%s): %s@%s [%s@%s#%u,%s#%u] %c %lu %luKb %lu %luKb\n",
+#endif
+#endif /* LOG_IP */
 		myctime(cptr->firsttime), msg ? msg : buf,
 		username, hostname, cptr->auth,
+#ifdef LOG_IP
+                rip,rport,lip,lport,
+#endif /* LOG_IP */
+#ifdef LOG_IRCNAME
+		cptr->info,
+#endif
 		cptr->exitc, cptr->sendM, cptr->sendK,
 		cptr->receiveM, cptr->receiveK);
 
diff -Nur irc2.10.3p7/common/struct_def.h irc2.10.3p7+hemp2+DK+B5/common/struct_def.h
--- irc2.10.3p7/common/struct_def.h	Mon May 14 14:02:08 2001
+++ irc2.10.3p7+hemp2+DK+B5/common/struct_def.h	Tue May 11 15:25:01 2004
@@ -25,6 +25,7 @@
 typedef	struct	Server	aServer;
 typedef	struct	Service	aService;
 typedef	struct	SLink	Link;
+typedef	struct	invSLink	invLink;
 typedef	struct	SMode	Mode;
 typedef	struct	fdarray	FdAry;
 typedef	struct	CPing	aCPing;
@@ -47,7 +48,7 @@
 				*/
 #define	USERLEN		10
 #define	REALLEN	 	50
-#define	TOPICLEN	80
+#define	TOPICLEN	160
 #define	CHANNELLEN	50
 #define	PASSWDLEN 	20
 #define	KEYLEN		23
@@ -60,7 +61,8 @@
 #define	CHIDLEN		5		/* WARNING: *DONT* CHANGE THIS!!!! */
 
 #define	READBUF_SIZE	16384	/* used in s_bsd.c *AND* s_zip.c ! */
- 
+
+#define	MAXMODEPARAMS	3 	/* do _!not!_ change this */
 /*
  * Make up some numbers which should reflect average leaf server connect
  * queue max size.
@@ -166,6 +168,9 @@
 #define	FLAGS_ZIP      0x400000 /* link is zipped */
 #define	FLAGS_ZIPRQ    0x800000 /* zip requested */
 #define	FLAGS_ZIPSTART 0x1000000 /* start of zip (ignore any CRLF) */
+#ifdef SPLIT_HANDLE
+#define FLAGS_EOBWAIT  0x2000000 /* waiting for EOB */
+#endif
 #define	FLAGS_HELD     0x8000000 /* connection held and reconnect try */
 
 #define	FLAGS_OPER       0x0001	/* Operator */
@@ -175,6 +180,11 @@
 #define FLAGS_RESTRICTED 0x0010 /* Restricted user */
 #define FLAGS_AWAY       0x0020 /* user is away */
 
+#define FLAGS_BADBOY     0x10000 /* delay close this client */
+#ifdef ILINE_FLAGS
+#define	FLAGS_EXEMPT	 0x20000 /* user is exempt from k-lines */
+
+#endif
 #define	SEND_UMODES	(FLAGS_INVISIBLE|FLAGS_OPER|FLAGS_WALLOP|FLAGS_AWAY)
 #define	ALL_UMODES	(SEND_UMODES|FLAGS_LOCOP|FLAGS_RESTRICTED)
 
@@ -222,6 +232,14 @@
 #define	ClearXAuth(x)		((x)->flags &= ~FLAGS_XAUTH)
 #define	ClearWXAuth(x)		((x)->flags &= ~FLAGS_WXAUTH)
 
+#ifdef SPLIT_HANDLE
+#define SetBurst(x)		((x)->flags |= FLAGS_EOBWAIT)
+#define ClearBurst(x)		((x)->flags &= ~FLAGS_EOBWAIT)
+#define IsBurst(x)		((x)->flags & FLAGS_EOBWAIT)
+#endif
+#ifdef ILINE_FLAGS
+#define IsKlineExempt(x)	((x)->user && (x)->user->flags & FLAGS_EXEMPT)
+#endif
 /*
  * defined debugging levels
  */
@@ -268,6 +286,7 @@
 	u_int	pref;		/* preference value */
 	struct	CPing	*ping;
 	time_t	hold;	/* Hold action until this time (calendar time) */
+	char	*source_ip;
 #ifndef VMSP
 	aClass	*class;  /* Class of connection */
 #endif
@@ -276,6 +295,15 @@
 
 #define	CONF_ILLEGAL		0x80000000
 #define	CONF_MATCH		0x40000000
+#ifdef DELAY_ACCEPT
+#define CONF_DELAY		0x20000000
+#define CONF_ACTIVE		0x10000000
+#define CONF_SERVERONLY		0x8000000
+#endif
+#ifdef ILINE_FLAGS
+#define CONF_EXEMPT		0x4000000  /* user is exempted from K: */
+#define CONF_RNODNS		0x2000000
+#endif
 #define	CONF_QUARANTINED_SERVER	0x000001
 #define	CONF_CLIENT		0x000002
 #define CONF_RCLIENT            0x000004
@@ -287,9 +315,6 @@
 #define	CONF_ME			0x000100
 #define	CONF_KILL		0x000200
 #define	CONF_ADMIN		0x000400
-#ifdef 	R_LINES
-#define	CONF_RESTRICT		0x000800
-#endif
 #define	CONF_CLASS		0x001000
 #define	CONF_SERVICE		0x002000
 #define	CONF_LEAF		0x004000
@@ -345,7 +370,7 @@
  */
 struct	User	{
 	Link	*channel;	/* chain of channel pointer blocks */
-	Link	*invited;	/* chain of invite pointer blocks */
+	invLink	*invited;	/* chain of invite pointer blocks */
 	Link	*uwas;		/* chain of whowas pointer blocks */
 	char	*away;		/* pointer to away message */
 	time_t	last;		/* "idle" time */
@@ -368,6 +393,8 @@
 	char	username[USERLEN+1];
 	char	host[HOSTLEN+1];
 	char	*server;
+	struct User *hnext;	
+	int 	hashv;		
 };
 
 struct	Server	{
@@ -382,6 +409,10 @@
 				** from anUser (field servp), aService (field
 				** servp) and aClient (field serv)
 				*/
+	int	usercnt[3]; 	/* # of clients - all, invisible, opers */
+#ifdef EXTRA_STATISTICS
+	int	usermax;	/* max # of users  on this server */
+#endif
 	struct	Server	*nexts, *prevs, *shnext;
 	aClient	*bcptr;
 	char	by[NICKLEN+1];
@@ -389,6 +420,7 @@
 	time_t	lastload;	/* penalty like counters, see s_serv.c
 				** should be in the local part, but..
 				*/
+	Link 	*down;		/* list of downlinks */
 };
 
 struct	Service	{
@@ -451,6 +483,7 @@
 				  ** accepted.
 				  */
 	char	passwd[PASSWDLEN+1];
+	char	*reason;	/* internal quit reason */
 	char	exitc;
 };
 
@@ -531,6 +564,16 @@
 	u_long	bytes;
 };
 
+#ifdef SPLIT_HANDLE
+#define SET_TYPE_INT 0
+#define SET_TYPE_STRING 1
+struct Set_Message {
+	char *cmd;
+	int *value;
+	char **values;
+};
+#endif
+
 #define	MSG_LAG		0x0001
 #define	MSG_NOU		0x0002	/* Not available to users */
 #define	MSG_SVC		0x0004	/* Services only */
@@ -563,6 +606,20 @@
 	int	flags;
 };
 
+/* invite link structure used for chains */
+struct invSLink        {
+	struct  invSLink        *next;
+	union {
+		aClient *cptr;
+		aChannel *chptr;
+		aConfItem *aconf;
+		char    *cp;
+		int     i;
+	} value;
+	int     flags;
+	char    *who;
+};
+
 /* channel structure */
 
 struct Channel	{
@@ -570,6 +627,10 @@
 	u_int	hashv;		/* raw hash value */
 	Mode	mode;
 	char	topic[TOPICLEN+1];
+#ifdef TOPICWHOTIME
+	char    topic_nuh[BANLEN+1];
+	time_t  topic_time;
+#endif
 	int	users;		/* current membership total */
 	Link	*members;	/* channel members */
 	Link	*invites;	/* outstanding invitations */
@@ -674,6 +735,18 @@
 				  x->prev->service->servp == x->serv)))
 
 typedef	struct	{
+#ifdef	EXTRA_STATISTICS
+	time_t	is_l_myclnt_t;	/* timestamp for last count */
+	u_long	is_l_myclnt;	/* last local user count */
+	time_t	is_m_users_t;	/* timestamp of last maximum users */
+	time_t	is_m_myclnt_t;	/* timestamp of last maximum local clients */
+	u_long	is_m_users;	/* maximum users connected */
+	u_long	is_m_serv;	/* maximum servers connected */
+	u_long	is_m_service;	/* maximum services connected */
+	u_long	is_m_myclnt;	/* maximum local clients */
+	u_long	is_m_myserv;	/* maximum local servers */
+	u_long	is_m_myservice;	/* maximum local services */
+#endif
 	u_long	is_user[2];	/* users, non[0] invis and invis[1] */
 	u_long	is_serv;	/* servers */
 	u_long	is_service;	/* services */
@@ -715,8 +788,21 @@
 	u_int	is_dbufmin;	/* min number of dbuf in use */
 	u_int	is_dbufmax;	/* max number of dbuf in use */
 	u_int	is_dbufmore;	/* how many times we increased the bufferpool*/
+#ifdef DELAY_CLOSE
+	u_long  is_delayclosed;
+#endif
+#ifdef SPLIT_HANDLE
+	u_long	is_eobservers;  /* # of servers which sent EOB */
+#endif
 } istat_t;
 
+typedef struct {
+	u_int split;
+	u_int aconnect; 	/* if we want aconnect or not */
+#ifdef DELAY_ACCEPT
+	u_int caccept;		/* enable/disable client ports */
+#endif
+} iconf_t;
 /* String manipulation macros */
 
 /* strncopynt --> strncpyzt to avoid confusion, sematics changed
@@ -771,8 +857,13 @@
 #define	SCH_SERVICE	9
 #define	SCH_DEBUG	10
 #define	SCH_AUTH	11
-#define	SCH_MAX		11
 
+#ifdef CLIENTS_CHANNEL 
+#define SCH_CLIENTS	12
+#define SCH_MAX 13
+#else
+#define SCH_MAX 12
+#endif
 /* used for async dns values */
 
 #define	ASYNC_NONE	(-1)
@@ -793,7 +884,6 @@
 #define EXITC_MBUF	'M'	/* mem alloc error */
 #define EXITC_PING	'P'	/* ping timeout */
 #define EXITC_SENDQ	'Q'	/* send queue exceeded */
-#define EXITC_RLINE	'r'	/* R-lined */
 #define EXITC_REF	'R'	/* Refused */
 #define EXITC_AREF	'U'	/* Unauthorized by iauth */
 #define EXITC_AREFQ	'u'	/* Unauthorized by iauth, be quiet */
diff -Nur irc2.10.3p7/common/support.c irc2.10.3p7+hemp2+DK+B5/common/support.c
--- irc2.10.3p7/common/support.c	Thu May 31 16:00:02 2001
+++ irc2.10.3p7+hemp2+DK+B5/common/support.c	Tue May 11 15:25:01 2004
@@ -849,7 +849,7 @@
 char *make_version()
 {
 	int ve, re, mi, dv, pl;
-	char ver[15];
+	char ver[50];
 
 	sscanf(PATCHLEVEL, "%2d%2d%2d%2d%2d", &ve, &re, &mi, &dv, &pl);
 	/* version & revision */
@@ -861,9 +861,31 @@
 		sprintf(ver + strlen(ver), "%c%d", DEVLEVEL, dv);
 	if (pl)	/* patchlevel */
 		sprintf(ver + strlen(ver), "p%d", pl);
+	strcat(ver,"+hemp2");
+	strcat(ver,"+DK+B5");
 	return mystrdup(ver);
 }
+#ifndef CLIENTCOMPILE
+#ifdef SEND_ISUPPORT
+/*
+ * Make ISUPPORT string 
+ */
 
+char *make_isupport()
+{
+	char tisupport[200];
+	char *p = tisupport;
+#ifdef SERVER_MAP
+	strcpy(tisupport,"MAP ");
+	p +=4;
+#endif
+	SPRINTF(p,"PREFIX=(ov)@+ MODES=%d CHANTYPES=#&!+ MAXCHANNELS=%d NICKLEN=%d TOPICLEN=%d KICKLEN=%d NETWORK=%s CHANMODES=beI,k,l,imnpstaqr",
+			      MAXMODEPARAMS, MAXCHANNELSPERUSER, NICKLEN, TOPICLEN, TOPICLEN,NETWORKNAME);
+
+	return mystrdup(tisupport);
+}
+#endif
+#endif
 #ifndef HAVE_TRUNCATE
 /* truncate: set a file to a specified length
  * I don't know of any UNIX that doesn't have truncate, but CYGWIN32 beta18
diff -Nur irc2.10.3p7/common/support_ext.h irc2.10.3p7+hemp2+DK+B5/common/support_ext.h
--- irc2.10.3p7/common/support_ext.h	Fri Dec  8 23:15:21 2000
+++ irc2.10.3p7+hemp2+DK+B5/common/support_ext.h	Tue May 11 15:25:01 2004
@@ -72,6 +72,9 @@
 #endif /* USE_STDARG */
 EXTERN int dgets __P((int fd, char *buf, int num));
 EXTERN char *make_version();
+#ifdef SEND_ISUPPORT
+EXTERN char *make_isupport();
+#endif
 #if SOLARIS_2_3
 EXTERN struct hostent *solaris_gethostbyname __P((const char *name));
 #endif /* SOLARIS_2_3 */
diff -Nur irc2.10.3p7/doc/example.conf irc2.10.3p7+hemp2+DK+B5/doc/example.conf
--- irc2.10.3p7/doc/example.conf	Wed Jul 14 18:17:23 1999
+++ irc2.10.3p7+hemp2+DK+B5/doc/example.conf	Tue May 11 15:25:01 2004
@@ -496,30 +496,6 @@
 #
 #
 ############################
-# R: [DISCOURAGED]. These lines restrict user access based on a more
-# stringent checking system than is available in the K: line. It looks for
-# a match (based on hostname and username) and then runs an outside
-# program (which MUST be specified using a full pathname). The output of
-# the program should be a string in the form "Y <message>" (which permits
-# access for the user) or "N <message>" (which denies access for the
-# user). If "Y <message>" is received by the server, the server ignores
-# the message and permits access for the user. If "N <message>" is
-# returned, the server tells the user that he/she is not permitted to
-# access that irc server, and gives the reason.
-#
-# Again, like K: lines, R: lines are local and thus not very effective in
-# blocking certain machines from having IRC access.
-#
-# Use of R: requires that you have defined R_LINES in config.h
-#
-# The fields are as follows:
-# R:hostmask:/full/path/to/program:username
-# you can use wildcards in either the hostmask or username portion
-#
-R:csl.bu.edu:/home/hrose/bin.sun3/sun3access:*::
-#
-#
-############################
 # Q: [DISCOURAGED]. These lines "quarantine" specified servers.  Because
 # of the way they operates, the same Q: lines MUST be installed by
 # everyone or the net will keep breaking. I CANNOT EMPHASIZE THIS ENOUGH.
diff -Nur irc2.10.3p7/iauth/a_conf.c irc2.10.3p7+hemp2+DK+B5/iauth/a_conf.c
--- irc2.10.3p7/iauth/a_conf.c	Sat Oct 11 16:22:56 2003
+++ irc2.10.3p7+hemp2+DK+B5/iauth/a_conf.c	Tue May 11 15:25:02 2004
@@ -26,6 +26,7 @@
 #define A_CONF_C
 #include "a_externs.h"
 #undef A_CONF_C
+#undef USE_DSM
 
 static aModule *Mlist[16];
 
@@ -87,8 +88,10 @@
 
 	Mlist[Mcnt++] = &Module_rfc931;
 	Mlist[Mcnt++] = &Module_socks;
+	Mlist[Mcnt++] = &Module_webproxy;
 	Mlist[Mcnt++] = &Module_pipe;
 	Mlist[Mcnt++] = &Module_lhex;
+	Mlist[Mcnt++] = &Module_dnsbl;
 	Mlist[Mcnt] = NULL;
 
 	cfh = fopen((cfile) ? cfile : IAUTHCONF_PATH, "r");
@@ -248,6 +251,7 @@
 			(*last)->hostname = NULL;
 			(*last)->address = NULL;
 			(*last)->timeout = timeout;
+			(*last)->reason = NULL;
 			if (Mlist[i] == &Module_rfc931)
 				ident = *last;
 
@@ -291,6 +295,17 @@
 							mystrdup(buffer + 10);
 					continue;
 				    }
+				if (!strncasecmp(buffer+1, "reason = ", 9))
+				{
+					if ((*last)->reason)
+						conf_err(lnnb,
+					"Duplicate reason keyword: ignored.",
+							cfile);
+					else
+						(*last)->reason =
+							mystrdup(buffer + 10);
+					continue;
+				}
 				if (!strncasecmp(buffer+1, "host = ", 7))
 				    {
 					needh = 1;
@@ -417,6 +432,8 @@
 		    {
 			printf("\t%s\t%s\n", itmp->mod->name,
 			       (itmp->opt) ? itmp->opt : "");
+			if (itmp->reason)
+				printf("\t\tReason = %s\n", itmp->reason);
 			if (ttmp = itmp->hostname)
 			    {
 				printf("\t\tHost = %s%s",
diff -Nur irc2.10.3p7/iauth/a_conf_def.h irc2.10.3p7+hemp2+DK+B5/iauth/a_conf_def.h
--- irc2.10.3p7/iauth/a_conf_def.h	Mon Jul  5 00:09:09 1999
+++ irc2.10.3p7+hemp2+DK+B5/iauth/a_conf_def.h	Tue May 11 15:25:02 2004
@@ -40,6 +40,7 @@
     u_char	in;			/* instance number */
     aModule	*mod;			/* module */
     char	*opt;			/* options read from file */
+    char	*reason;		/* reject reason */
     char	*popt;			/* options to send to ircd */
     void	*data;			/* private data: stats, ... */
     aTarget	*address;
diff -Nur irc2.10.3p7/iauth/a_externs.h irc2.10.3p7+hemp2+DK+B5/iauth/a_externs.h
--- irc2.10.3p7/iauth/a_externs.h	Mon Apr 12 21:45:04 1999
+++ irc2.10.3p7+hemp2+DK+B5/iauth/a_externs.h	Tue May 11 15:25:02 2004
@@ -30,5 +30,7 @@
 
 #include "mod_rfc931_ext.h"
 #include "mod_socks_ext.h"
+#include "mod_webproxy_ext.h"
 #include "mod_pipe_ext.h"
 #include "mod_lhex_ext.h"
+#include "mod_dnsbl_ext.h"
diff -Nur irc2.10.3p7/iauth/a_log_def.h irc2.10.3p7+hemp2+DK+B5/iauth/a_log_def.h
--- irc2.10.3p7/iauth/a_log_def.h	Thu Oct 18 21:51:08 2001
+++ irc2.10.3p7+hemp2+DK+B5/iauth/a_log_def.h	Tue May 11 15:25:02 2004
@@ -37,5 +37,9 @@
 #define	ALOG_DSOCKSC	0x040000	/* debug: module socks cache */
 #define	ALOG_DPIPE	0x080000	/* debug: module pipe */
 #define	ALOG_DLHEX	0x100000	/* debug: module pipe */
+#define ALOG_DNSBL      0x200000        /* debug: module dnsbl */
+#define ALOG_DNSBLC     0x200000        /* debug: module dnsbl cache */
+#define	ALOG_DWEBPROXY	0x400000	/* debug: module webproxy */
+#define	ALOG_DALL	0x7F3700	/* any debug flag */
 
-#define	ALOG_DALL	0x1F3700	/* any debug flag */
+#define	ALOG_DALL	0x7F3700	/* any debug flag */
diff -Nur irc2.10.3p7/iauth/iauth.c irc2.10.3p7+hemp2+DK+B5/iauth/iauth.c
--- irc2.10.3p7/iauth/iauth.c	Wed May 16 12:42:51 2001
+++ irc2.10.3p7+hemp2+DK+B5/iauth/iauth.c	Tue May 11 15:25:02 2004
@@ -135,6 +135,24 @@
 #endif
 }
 
+void    write_pidfile()
+{
+        int fd;
+        char buff[20];
+        (void)truncate(IAUTHPID_PATH, 0);
+        if ((fd = open(IAUTHPID_PATH, O_CREAT|O_WRONLY, 0600))>=0)
+            {
+                bzero(buff, sizeof(buff));
+                (void)sprintf(buff,"%5d\n", (int)getpid());
+                if (write(fd, buff, strlen(buff)) == -1)
+			(void)printf("Error writing to pid file %s",
+				IAUTHPID_PATH);
+                (void)close(fd);
+                return;
+            }
+}
+
+
 int	main(argc, argv)
 int	argc;
 char	*argv[];
@@ -197,6 +215,7 @@
 #endif
 		sendto_ircd("G 0");
 
+	write_pidfile();
 	while (1)
 	    {
 		loop_io();
